#ifndef UNICODE_H
#define UNICODE_H

#include <string>
using std::string;

void ListAvailableUnicodeSubsets(const char *fontname);
bool DoesFontHaveUnicode(const char *fontname);

// Information from http://msdn.microsoft.com/library/default.asp?url=/library/en-us/intl/unicode_63ub.asp

struct UnicodeSubset_t
{
	const char *name;
	int range[2];
	int set;
	bool isAvailable;
};

extern UnicodeSubset_t UnicodeSubsets[];

extern const int numUnicodeSubsets;

string GetCharSetName(int charSet);
int GetCharSet(const char *charSetName);

#endif